; 

    .486                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive

WinMain proto :DWORD, :DWORD, :DWORD, :DWORD

    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\Comctl32.inc
    include \masm32\include\comdlg32.inc
    include \masm32\include\shell32.inc
    include \masm32\include\oleaut32.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\Comctl32.lib
    includelib \masm32\lib\comdlg32.lib
    includelib \masm32\lib\shell32.lib
    includelib \masm32\lib\oleaut32.lib

; 
         .const
IDB_BUTTON equ 2
IDD_MAINDLG equ 1
IDB_EXIT equ 3

         .data
ClassName db "DLGCLASS", 0
MBText db "Button has been pressed", 0
MBCaption db "Information", 0
         .data?
         
hInstance HINSTANCE ?
CommandLine LPSTR ?
hDlg HANDLE ?

.code
; 

start:
 
; 
invoke GetModuleHandle, NULL
mov hInstance, eax
invoke GetCommandLine
mov CommandLine, eax
invoke InitCommonControls
invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWNORMAL
invoke ExitProcess, NULL

WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
             LOCAL Msg:MSG
             LOCAL wc:WNDCLASSEX
                       mov wc.cbSize, sizeof WNDCLASSEX
                       mov wc.style, CS_HREDRAW or CS_VREDRAW
                       mov wc.lpfnWndProc, OFFSET WndProc
                       mov wc.cbClsExtra, NULL
                       mov wc.cbWndExtra, DLGWINDOWEXTRA
                       push hInst
                       pop wc.hInstance
                       invoke LoadIcon, NULL, IDI_APPLICATION
                       mov wc.hIcon, eax
                       mov wc.hIconSm, eax
                       invoke LoadCursor, NULL, IDC_ARROW
                       mov wc.hCursor, eax
                       mov wc.hbrBackground, COLOR_BTNFACE+1
                       mov wc.lpszMenuName, NULL
                       mov wc.lpszClassName, OFFSET ClassName
                       invoke RegisterClassEx, addr wc
                       invoke CreateDialogParam, hInstance, IDD_MAINDLG, NULL, NULL, NULL
                       mov hDlg, eax
                      .while TRUE
                       invoke GetMessage, addr Msg, NULL, 0, 0
                       .break .if (!eax)
                       invoke IsDialogMessage, hDlg, addr Msg
                       .if eax==FALSE
                       invoke TranslateMessage, addr Msg
                       invoke DispatchMessage, addr Msg
                       .endif
                       .endw
ret
WinMain endp

WndProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
              LOCAL ti:TOOLINFO
              LOCAL rect:RECT

              .if uMsg==WM_DESTROY         
              invoke PostQuitMessage, NULL
              .elseif uMsg==WM_COMMAND
              mov eax, wParam
              .if ax==IDB_BUTTON
              invoke MessageBox, hDlg, addr MBText, addr MBCaption, MB_OK or MB_ICONINFORMATION
              .else 
              invoke DestroyWindow, hWnd
              .endif
              .elseif
              invoke DefWindowProc, hWnd, uMsg, wParam, lParam
              ret
              .endif
xor eax, eax
ret
WndProc endp

; 

end start
